#include <QtOpenGL>
#include "scene.h"

Scene::Scene() {

}

Scene::~Scene() {

}

void Scene::render() {
    double cubeSize = 50.0;
    glBegin(GL_QUADS);
        // front
        glColor3d(1.0, 0.0, 0.0);
        glVertex3d(-cubeSize / 2.0, -cubeSize / 2.0, cubeSize / 2.0);
        glVertex3d(cubeSize / 2.0, -cubeSize / 2.0, cubeSize / 2.0);
        glVertex3d(cubeSize / 2.0, cubeSize / 2.0, cubeSize / 2.0);
        glVertex3d(-cubeSize / 2.0, cubeSize / 2.0, cubeSize / 2.0);

        // left
        glColor3d(0.0, 1.0, 0.0);
        glVertex3d(-cubeSize / 2.0, -cubeSize / 2.0, -cubeSize / 2.0);
        glVertex3d(-cubeSize / 2.0, -cubeSize / 2.0, cubeSize / 2.0);
        glVertex3d(-cubeSize / 2.0, cubeSize / 2.0, cubeSize / 2.0);
        glVertex3d(-cubeSize / 2.0, cubeSize / 2.0, -cubeSize / 2.0);

        // right
        glColor3d(0.0, 0.0, 1.0);
        glVertex3d(cubeSize / 2.0, -cubeSize / 2.0, -cubeSize / 2.0);
        glVertex3d(cubeSize / 2.0, -cubeSize / 2.0, cubeSize / 2.0);
        glVertex3d(cubeSize / 2.0, cubeSize / 2.0, cubeSize / 2.0);
        glVertex3d(cubeSize / 2.0, cubeSize / 2.0, -cubeSize / 2.0);

        // back
        glColor3d(0.0, 1.0, 1.0);
        glVertex3d(-cubeSize / 2.0, -cubeSize / 2.0, -cubeSize / 2.0);
        glVertex3d(cubeSize / 2.0, -cubeSize / 2.0, -cubeSize / 2.0);
        glVertex3d(cubeSize / 2.0, cubeSize / 2.0, -cubeSize / 2.0);
        glVertex3d(-cubeSize / 2.0, cubeSize / 2.0, -cubeSize / 2.0);

        // bottom
        glColor3d(1.0, 0.0, 1.0);
        glVertex3d(-cubeSize / 2.0, -cubeSize / 2.0, -cubeSize / 2.0);
        glVertex3d(cubeSize / 2.0, -cubeSize / 2.0, -cubeSize / 2.0);
        glVertex3d(cubeSize / 2.0, -cubeSize / 2.0, cubeSize / 2.0);
        glVertex3d(-cubeSize / 2.0, -cubeSize / 2.0, cubeSize / 2.0);

        // top
        glColor3d(1.0, 1.0, 0.0);
        glVertex3d(-cubeSize / 2.0, cubeSize / 2.0, -cubeSize / 2.0);
        glVertex3d(cubeSize / 2.0, cubeSize / 2.0, -cubeSize / 2.0);
        glVertex3d(cubeSize / 2.0, cubeSize / 2.0, cubeSize / 2.0);
        glVertex3d(-cubeSize / 2.0, cubeSize / 2.0, cubeSize / 2.0);
    glEnd();

    double gridSize = 20.0;

    for(int x = -8; x <= 8; x++) {
        for(int y = -8; y <= 8; y++) {
            glBegin(GL_LINE_LOOP);
                glColor3d(0.25, 0.25, 0.25);
                glVertex3d(x * gridSize - gridSize / 2.0, 0.0, y * gridSize - gridSize / 2.0);
                glVertex3d(x * gridSize + gridSize / 2.0, 0.0, y * gridSize - gridSize / 2.0);
                glVertex3d(x * gridSize + gridSize / 2.0, 0.0, y * gridSize + gridSize / 2.0);
                glVertex3d(x * gridSize - gridSize / 2.0, 0.0, y * gridSize + gridSize / 2.0);
            glEnd();
        }
    }
}
